
#include<stdio.h>
#include<stdlib.h>
#include<netinet/in.h>
#include<string.h>
#include<pthread.h>

#include"sitar.h"
#include"sitar_com.h"
#include<almemsys/almemsys.h>
#include"jpreturn.h"


// #define SCAN_TSERVER_DEBUG

// コマンド監視モード
char * scan_test_server_command(char * backdata, char * listdata, char * dns_ip, char * ipip, int timeout, int * pst)
{
int stat, los, co, con;
char * comdata;
char * ip_data;
char * sock_ip;
char * tmpdata;
char * tmpip;
char * compath = "/usr/local/zither/bin/scan_block_test";

stat = 0;
los = 0;
co = 0;
con = 0;

comdata = (char *)calloc(BUF_LEN, sizeof(char));
ip_data = (char *)calloc(BUF_LEN, sizeof(char));
sock_ip = (char *)calloc(BUF_LEN, sizeof(char));
tmpdata = (char *)calloc(BUF_LEN, sizeof(char));
tmpip = (char *)calloc(BUF_LEN, sizeof(char));


// list の最後のからむのIP転送データを得る
ip_data = delim_get(listdata, ip_data, ',', &stat, 13);
rm_crlf(ip_data, strlen(ip_data));

// 転送データがある場合
if(0 < strlen(ip_data)){
   // 転送データにーがある場合
   con = char_count(ip_data, '-');

   if(1 < con){
      // 転送データの最初のからむからIPを取り出す、それが次の接続先
      sock_ip = delim_get(ip_data, sock_ip, '-', &stat, 0);
      // 最初のーから後ろを取り出してip_dataにする。それが次のlistdataの最後のからむ
      tmpip = delim_r(ip_data, tmpip, '-', 1);
      ip_data = safe_memcpy(ip_data, tmpip, BUF_LEN); 
      // listdata の最後のからむを消す 
      tmpdata = delim_f(listdata, tmpdata, ',', 13);
      listdata = safe_memcpy(listdata, tmpdata, BUF_LEN);
      // listdata の最後のからむをip_dataで置き換える

      listdata = safe_strncat(listdata, ip_data, BUF_LEN);

      #ifdef SCAN_TSERVER_DEBUG
      printf("=IN - %d ===ipip %s===sock_ip %s===ip_data %s=====\n", con, ipip, sock_ip, ip_data);
      #endif
      }
   else if(1 == con){
      // 転送データの最初のからむからIPを取り出す、それが次の接続先
      sock_ip = delim_get(ip_data, sock_ip, '-', &stat, 0);
      // 最初のーから後ろを取り出してip_dataにする。それが次のlistdataの最後のからむ
      tmpip = delim_get(ip_data, tmpip, '-', &stat, 1);
      ip_data = safe_memcpy(ip_data, tmpip, BUF_LEN); 
      // listdata の最後のからむを消す 
      tmpdata = delim_f(listdata, tmpdata, ',', 13);
      listdata = safe_memcpy(listdata, tmpdata, BUF_LEN);
      // listdata の最後のからむをip_dataで置き換える
      listdata = safe_strncat(listdata, ip_data, BUF_LEN);

      #ifdef SCAN_TSERVER_DEBUG
      printf("=IN - %d ===ipip %s===sock_ip %s===ip_data %s=====\n", con, ipip, sock_ip, ip_data);
      #endif
      }

   // 転送データにーがないので、そのままIPとして使う
   else{
      sock_ip = safe_memcpy(sock_ip, ip_data, BUF_LEN);
      #ifdef SCAN_TSERVER_DEBUG
      printf("=NOT - %d ==ipip %s===sock_ip %s===ip_data %s=====\n", con, ipip, sock_ip, ip_data);
      #endif

      // listdata の最後のからむを消す
      tmpdata = delim_f(listdata, tmpdata, ',', 13);
      listdata = safe_memcpy(listdata, tmpdata, BUF_LEN);

      }
   }
// 転送データがないのでIPは空です
else{
   sock_ip = safe_memcpy(sock_ip, "", 1024);
   #ifdef SCAN_TSERVER_DEBUG
   printf("==NOT IP ==%s=====\n", ipip);
   #endif
   }

// 自分がバインドしてるIPと転送先のIPが同じ場合ローカルコマンドを実行
if(0 == self_memcmp(sock_ip, ipip)){
   comdata = safe_sprintf(comdata, BUF_LEN,"%s -d '%s' -m 0 -r %s 2>&1", compath, listdata, dns_ip);
   backdata = execom(comdata, backdata, (timeout + 3), 1);
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(1): local sockip %s comdata %s\n", ipip, comdata);
   #endif
   los =1;
   }
// 転送先のIPが空の場合ローカルコマンドを実行
else if(0 == (int)strlen(sock_ip)){
   comdata = safe_sprintf(comdata, BUF_LEN,"%s -d '%s' -m 0 -r %s 2>&1", compath, listdata, dns_ip);
   backdata = execom(comdata, backdata, (timeout + 3), 1);
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(2): local sockip %s comdata %s\n", ipip, comdata);
   #endif
   los =1;
   } 
// 自分がバインドしているIPと転送先が違う場合、転送処理するようにコマンドを実行
else {
   comdata = safe_sprintf(comdata, BUF_LEN,"%s -d '%s' -m 0 -r %s -i %s 2>&1", compath, listdata, dns_ip, sock_ip);
   backdata = execom(comdata, backdata, (timeout + 3), 1);
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(3): repeat sockip %s comdata %s\n", ipip, comdata);
   #endif
   }



if(1 < strlen(backdata)){
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_command() sockip %s %s get monitor err\n", ipip, backdata);
   #endif
   }
if(1 >= strlen(backdata)){
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand() sockip %s %s goot job\n", ipip, comdata);
   #endif
   backdata = safe_memcpy(backdata, COM_3, BUF_MAX );
   }

#ifdef SCAN_TSERVER_DEBUG
printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(): sockip<%s> command<%s> count<%d>\n", ipip, backdata, (int)strlen(backdata));
#endif

swap_mem(backdata, '\n', ' ');
swap_mem(backdata, '\r', ' ');
swap_mem(backdata, ',', ' ');

if(2 > (int)strlen(backdata)){  // 改行分をいれる
   * pst = 0;
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(1): sockip %s good\n", ipip);
   #endif
   }
else{
   * pst = -1;
   #ifdef SCAN_TSERVER_DEBUG
   printf("SCAN_TSERVER_DEBUG: scan_test_server_comand(2): sockip %s err\n", ipip);
   #endif
   if(los == 1){
      tmpdata = safe_sprintf(tmpdata, BUF_LEN,"<%s>: %s\n", ipip, backdata);
      backdata = safe_memcpy(backdata, tmpdata, BUF_LEN);
      }
   }

free(comdata);
free(ip_data);
free(sock_ip);
free(tmpdata);
free(tmpip);

return backdata;
}




